
require("lib.middleclass")
tween = require("lib.tween.tween")

require("lua.Passengers")
require("lua.Floor")
require("lua.Elevator")

function love.load(argument)
  math.randomseed(os.time())
  math.random();math.random();math.random()
  MODE = string.upper(argument[2] or 'look')
  elevator = Elevator:new(Elevator.CAPACITY, Floor.NUMBER, Floor.CAPACITY)
end

function love.update(dt)
  tween.update(dt)
  elevator:update(dt, floors)
end

function love.draw()
  elevator:draw()
end

function love.keypressed(k)
  local num_k = tonumber(string.match(k,'kp(%d+)') or string.match(k,'^%d+$'))
  if elevator.floors[num_k] then
    elevator.floors[num_k]:addPassenger()
  end
  if k == 'r' then
    elevator.floors[math.random(Floor.NUMBER)]:addPassenger()
  end
  if k == ' ' then
    elevator.enabled = not elevator.enabled
  end
  if k == 'escape' then
    love.event.push('q')
  end
end
